﻿namespace MatModel
{
    internal class Program
    {//ввод спроса, предложения и тарифов
        static int insert(out int[] massupply, out int[] masdemand, out bool closeness, out int[,] mastarif)
        {

            Console.WriteLine("Введите количество поставщиков ");
            int a = Convert.ToInt32(Console.ReadLine());
            massupply = new int[a];
            for (int i = 0; i < a; i++)
            {
                Console.WriteLine("Введите предложение " + (i + 1) + " поставщика");
                massupply[i] = Convert.ToInt32(Console.ReadLine());
            }
            //переменная для дальнейшей проверки на закрытость
            int sumsupply = massupply.Sum();
            Console.WriteLine();
            Console.WriteLine("Введите количество потребителей ");
            int b = Convert.ToInt32(Console.ReadLine());
            masdemand = new int[b];
            for (int i = 0; i < b; i++)
            {
                Console.WriteLine("Введите спрос " + (i + 1) + " потребителя");
                masdemand[i] = Convert.ToInt32(Console.ReadLine());

            }
            //вторая переменная для дальнейшей проверки на закрытость
            int sumdemand = masdemand.Sum();
            //определяем флаг на закрытость задачи
            if (sumdemand == sumsupply)
            {
                closeness = true;
            }
            else closeness = false;

            mastarif = new int[a, b];
            for (int i = 0; i < mastarif.GetLength(0); i++)
            {
                for (int j = 0; j < mastarif.GetLength(1); j++)
                {

                    Console.WriteLine("Введите тариф " + (i + 1) + " поставщика для " + (j + 1) + " потребителя");
                    mastarif[i, j] = Convert.ToInt32(Console.ReadLine());
                }

            }
            return 0;
        }




        //метод северо западного угла
        static int NortWest(int[] massupply, int[] masdemand, int[,] mastarif, out int[,] result)
        {
            //результирующая матрица, количество строк равно количеству поставщиков, а число столбцов число потребителей
            result = new int[massupply.Length, masdemand.Length];

            for (int i = 0; i < result.GetLength(0); i++)
            {
                for (int j = 0; j < result.GetLength(1); j++)
                {
                    //так как в методе северо западного угла мы идем "лесенкой"
                    //ищем минимум из спроса и предложения
                    if (massupply[i] > masdemand[j])
                    {
                        //если спрос меньше, то значение ячейки в рейзультирующей матрице равно значению спроса по этому столбцу
                        result[i, j] = masdemand[j];
                        //вычитаем поставку из склада
                        massupply[i] = massupply[i] - masdemand[j];
                        //зануляем столбец спроса
                        masdemand[j] = masdemand[j] - masdemand[j];

                    }
                    //те же самые манипуляции но наоборот
                    else
                    {
                        result[i, j] = massupply[i];
                        masdemand[j] = masdemand[j] - massupply[i];
                        massupply[i] = massupply[i] - massupply[i];

                    }
                    //таким образом если спрос или предложение обнуляется, то ячейки без поставок заполняются нулями
                }

            }
            return 0;
        }



        //функция вывода матрицы и целевой функции
        static int output(int[,] result, int[,] mastarif, int[] OcenkaVertical, int[] OcenkaHorisontal, out bool degeneracy)
        {
            int Count = 0;
            for (int i = 0; i < result.GetLength(0); i++)
            {
                for (int j = 0; j < result.GetLength(1); j++)
                {
                    Console.Write(result[i, j] + " ");
                    if (result[i, j] != 0)
                    {
                        Count++;
                    }

                }
                Console.WriteLine("| " + OcenkaVertical[i] + " ");
                Console.WriteLine();
            }
            for (int i = 0; i < result.GetLength(1); i++)
            {


                Console.Write(OcenkaHorisontal[i] + " ");

            }
            Console.WriteLine();
            int L = 0;
            for (int i = 0; i < result.GetLength(0); i++)
            {
                for (int j = 0; j < result.GetLength(1); j++)
                {
                    L = L + result[i, j] * mastarif[i, j];
                }

            }
            Console.WriteLine("Целевая функция = " + L);
            if (Count == (result.GetLength(0) + result.GetLength(1) - 1))
            {
                degeneracy = true;
            }
            else degeneracy = false;
            return 0;
        }



        static int MinimumElement(int[] massupply, int[] masdemand, int[,] mastarif, out int[,] result)
        {
            result = new int[massupply.Length, masdemand.Length];
            int[,] buffer = (int[,])mastarif.Clone();
            int min = 9999;
            int mini = 0;
            int minj = 0;
            int Count = 0;
            int n = massupply.Length;
            int m = masdemand.Length;
            while (massupply.Sum() != 0 && masdemand.Sum() != 0)
            {
                for (int i = 0; i < mastarif.GetLength(0); i++)
                {
                    for (int j = 0; j < mastarif.GetLength(1); j++)
                    {
                        if (min > buffer[i, j])
                        { min = buffer[i, j];

                            mini = i;
                            minj = j;

                        }

                    }

                }

                if (massupply[mini] > masdemand[minj])
                {
                    //если спрос меньше, то значение ячейки в рейзультирующей матрице равно значению спроса по этому столбцу
                    result[mini, minj] = masdemand[minj];
                    //вычитаем поставку из склада
                    massupply[mini] = massupply[mini] - masdemand[minj];
                    //зануляем столбец спроса
                    masdemand[minj] = masdemand[minj] - masdemand[minj];

                    min = 9999;

                }
                //те же самые манипуляции но наоборот
                else
                {
                    result[mini, minj] = massupply[mini];
                    masdemand[minj] = masdemand[minj] - massupply[mini];
                    massupply[mini] = massupply[mini] - massupply[mini];

                    min = 9999;

                }
                buffer[mini, minj] = 99999;

            }



            return 0;
        }

        static int potencial(int[,] result, int[,] tarif, out int[] OcenkaVertical, out int[] OcenkaHorisontal)
        {
            OcenkaVertical = new int[result.GetLength(0)];
            OcenkaHorisontal = new int[result.GetLength(1)];
            bool flag1 = false;
            bool flag2 = true;
            bool fladI = true;
            bool fladJ = true;
            OcenkaVertical[0] = 0;
            for (int i = 0; i < result.GetLength(0); i++)   
            {
                for (int j = 0; j < result.GetLength(1); j++)
                {
                    if (result[i, j] > 0 && flag1 && fladJ)
                    {

                        OcenkaHorisontal[j] = tarif[i, j] - OcenkaVertical[i];

                        Console.WriteLine(OcenkaHorisontal[j] + " = " + tarif[i, j] + " -" + OcenkaVertical[i]);
                        flag2 = true;
                        flag1 = false;
                        fladJ = false;
                    }
                    if (result[i, j] > 0 && flag1 && fladI)
                    {
                        
                        OcenkaVertical[i] = tarif[i, j] - OcenkaHorisontal[j];
                        OcenkaVertical[0] = 0;
                        Console.WriteLine(OcenkaVertical[i]+" = "+tarif[i, j]+" -"+ OcenkaHorisontal[j]+" строка");
                        flag1 = true;
                        flag2 = false;
                        fladI = false;
                    }
                    if (result[i, j] > 0 && fladI)
                    {
                        OcenkaVertical[i] = tarif[i, j] - OcenkaHorisontal[j];
                        OcenkaVertical[0] = 0;
                        Console.WriteLine(OcenkaVertical[i] + " = " + tarif[i, j] + " -" + OcenkaHorisontal[j] + " строка");
                        fladI = false;
                        fladJ = true;
                        flag1 = true;
                    }


                }
                fladI = true;
                fladJ = true;
            }
                return 0;
        }
    
            //Console.WriteLine(OcenkaVertical[i] +" столбец");
            //OcenkaHorisontal[j] = tarif[i, j] - OcenkaVertical[j];
            //Console.WriteLine(OcenkaHorisontal[j] + " строка");
        


        static void Main(string[] args)
        {
            //переменные которые нужны для out в методах выше
            bool closeness, degeneracy;
            int[] massupply;
            int[] masdemand;
            int[,] mastarif;
            int[,] result;
            int[] OcenkaVertical;
            int[] OcenkaHorisontal;
            //ввод для решения методос северо западного угла
            //insert(out massupply, out masdemand, out closeness, out mastarif);
            //////проверка на закрытость
            //if (closeness)
            //{
            //    Console.WriteLine("Задача закрытая, можем составить опорный план методом северо-западного угла: ");
            //    NortWest(massupply, masdemand, mastarif, out result);
            //    output(result, mastarif, out degeneracy);
            //    //проверка на вырожденность
            //    if (degeneracy)
            //    {
            //        Console.WriteLine("Опорный план невырожденный");
            //    }
            //}
            //else
            //{
            //    Console.WriteLine("Задача не закрытая, такие я решать не умею :(");
            //}
            //ввод для решения методом минимального элемента
            insert(out massupply, out masdemand, out closeness, out mastarif);
            if (closeness)
            {
                Console.WriteLine("Задача закрытая, можем составить опорный план методом минимального элемента: ");
                MinimumElement(massupply, masdemand, mastarif, out result);
                potencial(result, mastarif,out OcenkaVertical, out OcenkaHorisontal);
                output(result, mastarif, OcenkaVertical, OcenkaHorisontal, out degeneracy);
                if (degeneracy)
                {
                    
                    Console.WriteLine("Опорный план невырожденный");
                    
                }
                else Console.WriteLine("Опорный план вырожденный, устранять вырожденность я пока не умею :(");
                
            }
            else
            {
                Console.WriteLine("Задача не закрытая, такие я решать не умею :(");
            }

            //Potencial potencial = new Potencial();
            //potencial.Ocenka();
            

        }
    }
}